{- | SuperCollider Ugen database.

The database is generated by an sclang program and is given by the constant value 'ugen_db', which is a list of 'U' entries.

> map length [ugen_db,ugen_db_core,ugen_db_ext] == [849,373,476]

-}
module Sound.Sc3.Ugen.Db where

import Control.Exception {- base -}
import Data.Char {- base -}
import Data.Function {- base -}
import Data.List {- base -}
import Data.List.Split {- base -}
import Data.Maybe {- base -}
import System.Process {- process -}

import Sound.Sc3.Common.Base {- hsc3 -}
import Sound.Sc3.Common.Math.Operator {- hsc3 -}
import Sound.Sc3.Common.Rate {- hsc3 -}

import Sound.Sc3.Ugen.Db.Record {- hsc3-db -}

import qualified Sound.Sc3.Ugen.Db.Cat as Cat {- hsc3-db -}
import qualified Sound.Sc3.Ugen.Db.Data as Data {- hsc3-db -}
import qualified Sound.Sc3.Ugen.Db.External.Cat as External.Cat {- hsc3-db -}
import qualified Sound.Sc3.Ugen.Db.External.Data as External.Data {- hsc3-db -}

-- | UGens that the generator mishandles or sclang treats specially (exc = exceptions).
exc_db :: [Sc3_U]
exc_db =
    [("MaxLocalBufs",[ir],ir,[I "count" 0],1,"LocalBuf count",False)
    ,("MulAdd",[ir,kr,ar],ar,[I "in" 0,I "mul" 0,I "add" 0],1,"Multiply add",False)
    ,("SetBuf",[ir],ir,[I "buf" 0,I "offset" 0,I "length" 0,I "array" 0],1,"Set local buffer",False)]

{- | 'read_meta' of 'Data.sc3_ugen_db'.

> mapM_ (putStrLn . ugen_name) ugen_db_core
> map ugen_name (filter u_is_demand_rate ugen_db)
> map ugen_name (filter (\u -> ugen_nondet u && ugen_nc_input u) ugen_db)
> map ugen_name (filter (\u -> u_has_mce_rule u) ugen_db_core)
-}
ugen_db_core :: [U]
ugen_db_core = map read_meta (Data.sc3_ugen_db ++ exc_db)

-- | 'read_meta' of 'External.Data.sc3_ugen_db_ext'.
--
-- > mapM_ (putStrLn . ugen_name) ugen_db_ext
ugen_db_ext :: [U]
ugen_db_ext = map read_meta External.Data.sc3_ugen_db_ext

-- | 'ugen_db_core' and 'ugen_db_ext'
--
-- > "SinOsc" `elem` map ugen_name ugen_db
ugen_db :: [U]
ugen_db = ugen_db_core ++ ugen_db_ext

-- | Lookup Ugen by name in given Db.
u_lookup_in :: [U] -> Case_Rule -> String -> Maybe U
u_lookup_in db cr nm = lookup_by (string_eq cr) nm (zip (map ugen_name db) db)

-- | Is the named Ugen in the "core" Ugen set?
ugen_is_core :: String -> Bool
ugen_is_core = isJust . u_lookup_in ugen_db_core Cs

-- | Lookup 'U' at 'ugen_db'.
--
-- > u_lookup Cs "Drand"
-- > fmap ugen_default_rate (u_lookup Cs "SinOsc") == Just Sound.Sc3.AudioRate
-- > fmap ugen_default_rate (u_lookup Ci "fft") == Just Sound.Sc3.ControlRate
u_lookup :: Case_Rule -> String -> Maybe U
u_lookup = u_lookup_in ugen_db

-- | 'u_lookup' of 'Ci'
u_lookup_ci :: String -> Maybe U
u_lookup_ci = u_lookup Ci

-- | 'u_lookup' of 'Cs'
u_lookup_cs :: String -> Maybe U
u_lookup_cs = u_lookup Cs

u_lookup_ci_err :: String -> U
u_lookup_ci_err nm = fromMaybe (error ("u_lookup_ci: " ++ nm)) (u_lookup_ci nm)

u_lookup_cs_err :: String -> U
u_lookup_cs_err nm = fromMaybe (error ("u_lookup_cs: " ++ nm)) (u_lookup_cs nm)

-- | Case insensitive lookup to find Sc3.Ugen name, ie. correct case rule.
--
-- > map ugen_sc3_name ["pv_Add","dfm1"] == ["PV_Add","DFM1"]
ugen_sc3_name :: String -> String
ugen_sc3_name nm = maybe (error "ugen_sc3_name") ugen_name (u_lookup_ci nm)

-- * Names

-- | Unary operator names, in enumerated sequence.
uop_names :: [String]
uop_names = map sc3_unary_op_name [minBound :: Sc3_Unary_Op .. maxBound]

-- | Binary operator names, in enumerated sequence.
binop_names :: [String]
binop_names = map sc3_binary_op_name [minBound :: Sc3_Binary_Op .. maxBound]

-- | Given db (core or ext or both) generate all names, including operators.
complete_names :: [U] -> [String]
complete_names db = map ugen_name db ++ uop_names ++ binop_names

-- * Categories

-- | Sc3-Category as "X>Y>Z" string.
type Sc3_Cat = String

-- | Sc3-Category-List as "A>B>C,X>Y>Z" string.
type Sc3_Cat_List = String

-- | Sc3.Ugen-Category-Table, each entry is (UGen, Sc3-Category-List).
type Sc3_Ugen_Cat_Table = [(String,Sc3_Cat_List)]

-- | List of UGens to exclude from user listings.
sc3_ugen_cat_exclusions :: [String]
sc3_ugen_cat_exclusions =
  ["AbstractIn"
  ,"AbstractOut"
  ,"AudioControl"
  ,"BasicOpUGen"
  ,"BinaryOpUGen"
  ,"BlockSize"
  ,"BufInfoUGenBase"
  ,"DUGen"
  ,"Fb"
  ,"FbC"
  ,"FbK"
  ,"FbL"
  ,"FbNode"
  ,"InfoUGenBase"
  ,"ListDUGen"
  ,"MultiOutDemandUGen"
  ,"MultiOutUGen"
  ,"NodeID"
  ,"OutputProxy"
  ,"PureMultiOutUGen"
  ,"ScopeOut"
  ,"ScopeOut2"
  ,"SharedIn"
  ,"SharedOut"
  ,"TrigControl"
  ,"UnaryOpUGen"
  ,"WidthFirstUGen"
  ]

sc3_ugen_cat_exclude :: Sc3_Ugen_Cat_Table -> Sc3_Ugen_Cat_Table
sc3_ugen_cat_exclude = filter (flip notElem sc3_ugen_cat_exclusions . fst)

sc3_ugen_cat_x :: Sc3_Ugen_Cat_Table
sc3_ugen_cat_x = sc3_ugen_cat_exclude Cat.sc3_ugen_cat

sc3_ugen_cat_ext_x :: Sc3_Ugen_Cat_Table
sc3_ugen_cat_ext_x = sc3_ugen_cat_exclude External.Cat.sc3_ugen_cat_ext

-- | Core and External UGens grouped together.
sc3_ugen_cat_composite_x :: Sc3_Ugen_Cat_Table
sc3_ugen_cat_composite_x = sc3_ugen_cat_x ++ sc3_ugen_cat_ext_x

-- | UGen-Category as (Category,Maybe Sub-Category)
type UGen_Cat = (String,Maybe String)

-- | An Sc3-Category is a @>@ separated list of names.
--   This function removes categories that do not start at "UGens".
--   UGen categories have at most two levels, hence 2-tuple.
sc3_ugen_cat_parse :: Sc3_Cat -> Maybe UGen_Cat
sc3_ugen_cat_parse c =
  case splitOn ">" c of
    ["UGens"] -> Nothing -- PureUGen...
    ["UGens",i] -> Just (i,Nothing)
    ["UGens",i,j] -> Just (i,Just j)
    _ -> Nothing

-- | 'error' variant.
sc3_ugen_cat_parse_err :: Sc3_Cat -> UGen_Cat
sc3_ugen_cat_parse_err = fromMaybe (error "sc3_ugen_cat_parse") . sc3_ugen_cat_parse

-- | Sc3-Category-Lists are written comma separated.
sc3_ugen_cat_list_parse :: Sc3_Cat_List -> [UGen_Cat]
sc3_ugen_cat_list_parse = mapMaybe sc3_ugen_cat_parse . splitOn ","

-- | If u is True then inverse of 'sc3_ugen_cat_parse', else near inverse (without "UGens>" prefix)
ugen_cat_to_sc3_cat :: Bool -> UGen_Cat -> Sc3_Cat
ugen_cat_to_sc3_cat u (c,i) =
  (if u then (++) "UGens>" else id)
  (case i of {Nothing -> c;Just j -> concat [c,">",j]})

-- | List of all categories.
ugen_categories_list :: Sc3_Ugen_Cat_Table -> [UGen_Cat]
ugen_categories_list = nub . sort . concatMap (sc3_ugen_cat_list_parse . snd)

-- | Lookup categories string of named UGen.
ugen_to_sc3_cat_list :: String -> Sc3_Cat_List
ugen_to_sc3_cat_list u = fromMaybe (error "ugen_to_sc3_cat_list") (lookup u sc3_ugen_cat_composite_x)

-- | List of UGen categories for named UGen.
--
-- > map ugen_categories ["SinOsc","LPF","WhiteNoise","CombN","Pan2","Rand","Gate","FreqShift","Decay","Demand","CuspN"]
ugen_categories :: String -> [UGen_Cat]
ugen_categories = sc3_ugen_cat_list_parse . ugen_to_sc3_cat_list

-- | (Category,[Maybe Sub-Category,[UGen-Name]])
type UGen_Cat_Table_Entry = (String,[(Maybe String,[String])])

-- | [UGen_Cat_Table_Entry]
type UGen_Cat_Table = [UGen_Cat_Table_Entry]

-- | Table listing UGens in each category.
--
-- > ugen_categories_table sc3_ugen_cat_x
-- > ugen_categories_table sc3_ugen_cat_ext_x
ugen_categories_table :: Sc3_Ugen_Cat_Table -> UGen_Cat_Table
ugen_categories_table cat =
  let collate_by_on_adjacent eq f g =
        let h l = case l of
                    [] -> error "collate_by_on_adjacent"
                    l0:_ -> (f l0,map g l)
        in map h . groupBy (eq `on` f)
      col = collate_by_on_adjacent (==) (fst . fst) (\x -> (snd (fst x),snd x))
      trs c = (c,map fst (filter ((c `elem`) . sc3_ugen_cat_list_parse . snd) cat))
  in col (filter (not . null . snd) (map trs (ugen_categories_list cat)))

-- | Lookup UGen's of indicated UGen_Cat in table.
ugen_category_elem :: UGen_Cat_Table -> UGen_Cat -> [String]
ugen_category_elem tbl (qc,qs) =
  case lookup qc tbl of
    Nothing -> error (show ("ugen_category_elem: no category",qc))
    Just e -> fromMaybe (error "ugen_category_elem: no sub-category") (lookup qs e)

-- * MENU

-- | Variant of 'readCreateProcess' using 'try' to catch 'IOException'
readCreateProcess_or_nil :: CreateProcess -> String -> IO String
readCreateProcess_or_nil cmd inp = do
  r <- try (readCreateProcess cmd inp) :: IO (Either IOException String)
  case r of
    Left _ -> return ""
    Right oup -> return oup

-- | dmenu to select UGen name from given U data-base.
--
-- > ugen_name_dmenu ugen_db_core
-- > ugen_name_dmenu ugen_db_ext
ugen_name_dmenu :: [U] -> IO String
ugen_name_dmenu =
  fmap (filter (not . isSpace)) .
  readCreateProcess_or_nil (proc "dmenu" ["-i"]) .
  unlines .
  map ugen_name

{- | Two-level dmenu <https://tools.suckless.org/dmenu/> process.
     First the set of Categories is given, then the UGens of the selected Category.
     dmenu requires less screen space and has nicer text search than xmenu. -}
ugen_cat_dmenu :: Sc3_Ugen_Cat_Table -> IO String
ugen_cat_dmenu c = do
  let lst = ugen_categories_list c
      tbl = ugen_categories_table c
      clr = filter (not . isSpace)
      dmenu = readCreateProcess (proc "dmenu" ["-i"]) . unlines
  u1 <- dmenu (map (ugen_cat_to_sc3_cat False) lst)
  fmap clr (dmenu (ugen_category_elem tbl (sc3_ugen_cat_parse_err ("UGens>" ++ clr u1))))

-- | dmenu for core UGens.
ugen_cat_dmenu_core :: IO String
ugen_cat_dmenu_core = ugen_cat_dmenu sc3_ugen_cat_x

-- | dmenu for external UGens.
ugen_cat_dmenu_ext :: IO String
ugen_cat_dmenu_ext = ugen_cat_dmenu sc3_ugen_cat_ext_x

-- | Plain menu file for xmenu <https://github.com/phillbush/xmenu>.
ugen_cat_xmenu_plain_str :: Sc3_Ugen_Cat_Table -> String
ugen_cat_xmenu_plain_str =
  let f (c,j) = ugen_cat_to_sc3_cat False c : map ('\t' :) j
      g (c,e) = map (\(i,j) -> ((c,i),j)) e
  in unlines . concatMap f . concatMap g . ugen_categories_table

-- | Tree menu file for xmenu <https://github.com/phillbush/xmenu>.
ugen_cat_xmenu_tree_str :: Sc3_Ugen_Cat_Table -> String
ugen_cat_xmenu_tree_str =
  let f (i,j) = case i of
                  Nothing -> map ('\t' :) j
                  Just k -> ('\t' : k) : map ("\t\t" ++) j
      g (c,s) = c : concatMap f s
  in unlines . concatMap g . ugen_categories_table

-- | Write set of xmenu UGen category menus to directory.
--
--  > ugen_cat_xmenu_wr "/home/rohan/sw/hsc3-db/lib/xmenu/"
ugen_cat_xmenu_wr :: FilePath -> IO ()
ugen_cat_xmenu_wr dir = do
  writeFile (dir ++ "ugen-core-plain.text") (ugen_cat_xmenu_plain_str sc3_ugen_cat_x)
  writeFile (dir ++ "ugen-ext-plain.text") (ugen_cat_xmenu_plain_str sc3_ugen_cat_ext_x)
  writeFile (dir ++ "ugen-core-tree.text") (ugen_cat_xmenu_tree_str sc3_ugen_cat_x)
  writeFile (dir ++ "ugen-ext-tree.text") (ugen_cat_xmenu_tree_str sc3_ugen_cat_ext_x)

-- | Run xmenu at table and return selected UGen-Name.
ugen_cat_xmenu :: Sc3_Ugen_Cat_Table -> IO String
ugen_cat_xmenu =
  fmap (filter (not . isSpace)) .
  readCreateProcess_or_nil (proc "xmenu" []) .
  ugen_cat_xmenu_tree_str

-- | xmenu for core UGens.
ugen_cat_xmenu_core :: IO String
ugen_cat_xmenu_core = ugen_cat_xmenu sc3_ugen_cat_x

-- | xmenu for external UGens.
ugen_cat_xmenu_ext :: IO String
ugen_cat_xmenu_ext = ugen_cat_xmenu sc3_ugen_cat_ext_x
